// Code generated by go-swagger; DO NOT EDIT.

// Copyright (c) 2021, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package api_collection

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/wso2/product-microgateway/adapter/internal/api/models"
)

// GetApisOKCode is the HTTP code returned for type GetApisOK
const GetApisOKCode int = 200

/*GetApisOK An array of API Metadata

swagger:response getApisOK
*/
type GetApisOK struct {

	/*
	  In: Body
	*/
	Payload *models.APIMeta `json:"body,omitempty"`
}

// NewGetApisOK creates GetApisOK with default headers values
func NewGetApisOK() *GetApisOK {

	return &GetApisOK{}
}

// WithPayload adds the payload to the get apis o k response
func (o *GetApisOK) WithPayload(payload *models.APIMeta) *GetApisOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get apis o k response
func (o *GetApisOK) SetPayload(payload *models.APIMeta) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetApisOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(200)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// GetApisUnauthorizedCode is the HTTP code returned for type GetApisUnauthorized
const GetApisUnauthorizedCode int = 401

/*GetApisUnauthorized Unauthorized. Invalid authentication credentials.

swagger:response getApisUnauthorized
*/
type GetApisUnauthorized struct {

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetApisUnauthorized creates GetApisUnauthorized with default headers values
func NewGetApisUnauthorized() *GetApisUnauthorized {

	return &GetApisUnauthorized{}
}

// WithPayload adds the payload to the get apis unauthorized response
func (o *GetApisUnauthorized) WithPayload(payload *models.Error) *GetApisUnauthorized {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get apis unauthorized response
func (o *GetApisUnauthorized) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetApisUnauthorized) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(401)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// GetApisInternalServerErrorCode is the HTTP code returned for type GetApisInternalServerError
const GetApisInternalServerErrorCode int = 500

/*GetApisInternalServerError Internal Server Error.

swagger:response getApisInternalServerError
*/
type GetApisInternalServerError struct {

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetApisInternalServerError creates GetApisInternalServerError with default headers values
func NewGetApisInternalServerError() *GetApisInternalServerError {

	return &GetApisInternalServerError{}
}

// WithPayload adds the payload to the get apis internal server error response
func (o *GetApisInternalServerError) WithPayload(payload *models.Error) *GetApisInternalServerError {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get apis internal server error response
func (o *GetApisInternalServerError) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetApisInternalServerError) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(500)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
