# WSO2 API Manager Project

## Project structure

```bash
├── api.yaml
├── api_meta.yaml
├── deployment_environments.yaml
├── Client-certificates
├── Definitions
│   └── swagger.yaml
├── Docs
├── Endpoint-certificates
├── Image
└── Sequences
    ├── fault-sequence
    ├── in-sequence
    └── out-sequence
```

## Deploy a minimal API

To deploy a minimal API, once the project is generated open `api.yaml` and edit the fields under the `data` attribute.

- `name` : Must not include spaces (i.e. MyAPI)
- `version` : A simple version string (i.e. v1.0.0)
- `context` : Context of the API (i.e. /MyAPI)
- `lifeCycleStatus` : Lifecycle status of the API (If you want to change the status of the API to `PUBLISHED`, modify this field to `PUBLISHED`)

`Definitions/swagger.yaml` contains a default swagger generated by the tool.
Replace `Definitions/swagger.yaml` **with your swagger file** (JSON also supported).

Import the API project using the command,
`apictl import api -f [directory path] -e [env name]`

